import { createAsyncThunk } from '@reduxjs/toolkit';
import axios from 'axios';
import { Token, LoginParams } from './types';
import pickBy from 'lodash/pickBy';
import identity from 'lodash/identity';

function replacer(key:string, value:string) {
  console.log(typeof value);
  if (key == 'token') {
    localStorage.setItem('token', JSON.stringify(value));
  } else { console.log(value)}
}

export const fetchToken = createAsyncThunk<Token[], LoginParams>(
  'token/fetchTokenStatus',
  async (params) => {
    const { login, password } = params;
    const { data } = await axios.post<Token[]>('/api/login', {
      params: pickBy(
        {
          login: login,
          password: password,
        },
        identity,
      ),
    });
    JSON.stringify(data, replacer);
    console.log(data, 4444);
    return data;
  },
);
